Subject: Re: [RFC PATCH 2/3] Makefile: wire up the clar unit testing framework

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 1 Aug 2024 11:32:10 +0200

On Wed, Jul 31, 2024 at 06:48:36PM +0200, René Scharfe wrote:
> Am 31.07.24 um 11:04 schrieb Patrick Steinhardt:
> > Wire up the clar unit testing framework by introducing a new
> > "unit-tests" executable. In contrast to the existing framework, this
> > will result in a single executable for all test suites. The ability to
> > pick specific tests to execute is retained via functionality built into
> > the clar itself.
> >
> > Note that we need to be a bit careful about how we need to invalidate
> > our Makefile rules. While we obviously have to regenerate the clar suite
> > when our test suites change, we also have to invalidate it in case any
> > of the test suites gets removed. We do so by using our typical pattern
> > of creating a `GIT-TEST-SUITES` file that gets updated whenever the set
> > of test suites changes, so that we can easily depend on that file.
> >
> > Another specialty is that we generate a "clar-decls.h" file. The test
> > functions are neither static, nor do they have external declarations.
> > This is because they are getting parsed via "generate.py", which then
> > creates the external generations that get populated into an array. These
> > declarations are only seen by the main function though.
> >
> > The consequence is that we will get a bunch of "missing prototypes"
> > errors from our compiler for each of these test functions. To fix those
> > errors, we extract the `extern` declarations from "clar.suite" and put
> > them into a standalone header that then gets included by each of our
> > unit tests. This gets rid of compiler warnings for every function which
> > has been extracted by "generate.py". More importantly though, it does
> > _not_ get rid of warnings in case a function really isn't being used by
> > anything. Thus, it would cause a compiler error if a function name was
> > mistyped and thus not picked up by "generate.py".
> >
> 
> > +$(UNIT_TEST_DIR)/clar.suite: $(patsubst %,$(UNIT_TEST_DIR)/%.c,$(UNIT_TESTS_SUITES)) GIT-TEST-SUITES
> > +	$(QUIET_GEN)$(UNIT_TEST_DIR)/clar/generate.py $(UNIT_TEST_DIR) >/dev/null
> 
> This uses the Python interpreter from the shebang line in generate.py,
> which is python.  On my system I only have python3 and python3.12, but
> not python.  Easily fixed, of course, but a way to configure the
> interpreter name would be nice.
> 
> This gave me extra motivation to come up with the clunky patch below
> to replace Python with sed and awk.  That and your statement that clar
> doesn't have to be perfect in the other thread. ;)

Neat! I would certainly prefer to not have a dependency on Python, and I
think awk(1) is a good alternative here that we already require anyway.

Also, another benefit of having our own script is that it allows us to
be more flexible with how exactly our tests are structured.

> It reverses the order of dependencies (builds clar-decls.h first), not
> sure if that has downsides.  And the sed pattern is simpler than the
> one in generate.py, just out of laziness.

We could even integrate the generation of clar-decls.h with the AWK
script.

I'll play around a bit with what you have, thanks a lot for working on
it!

Patrick